Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 4456)
+++ /palm/trunk/SOURCE/Makefile	(revision 4457)
@@ -25,4 +25,8 @@
 # -----------------
 # $Id$
+# exchange horiz has been modularized and exchange horiz 2d has been merged, dependencies updated
+# accordingly
+# 
+# 4453 2020-03-11 08:10:13Z raasch
 # dependencies for exchange horiz modified
 # 
@@ -192,6 +196,5 @@
 	disturb_heatflux.f90 \
 	dynamics_mod.f90 \
-	exchange_horiz_2d.f90 \
-	exchange_horiz.f90 \
+	exchange_horiz_mod.f90 \
 	fft_xy_mod.f90 \
 	flow_statistics.f90 \
@@ -352,4 +355,5 @@
 	modules.o
 advec_ws.o: \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o
@@ -362,5 +366,5 @@
 average_3d_data.o: \
 	cpulog_mod.o \
-	exchange_horiz_2d.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	module_interface.o \
@@ -383,4 +387,5 @@
 	advec_s_up.o \
 	diffusion_s.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o \
@@ -431,4 +436,5 @@
 	chem_photolysis_mod.o \
 	diffusion_s.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o \
@@ -477,19 +483,20 @@
 data_output_binary_module.o: \
 	mod_kinds.o
+data_output_mask.o: \
+	basic_constants_and_equations_mod.o \
+	bulk_cloud_model_mod.o \
+	chemistry_model_mod.o \
+	cpulog_mod.o \
+	diagnostic_output_quantities_mod.o \
+	exchange_horiz_mod.o \
+	mod_kinds.o \
+	mod_particle_attributes.o \
+	modules.o \
+	netcdf_interface_mod.o \
+	salsa_mod.o
 data_output_module.o: \
 	data_output_binary_module.o \
 	data_output_netcdf4_module.o \
 	mod_kinds.o
-data_output_mask.o: \
-	basic_constants_and_equations_mod.o \
-	bulk_cloud_model_mod.o \
-	chemistry_model_mod.o \
-	cpulog_mod.o \
-	diagnostic_output_quantities_mod.o \
-	mod_kinds.o \
-	mod_particle_attributes.o \
-	modules.o \
-	netcdf_interface_mod.o \
-	salsa_mod.o
 data_output_netcdf4_module.o: \
 	mod_kinds.o
@@ -521,4 +528,5 @@
 	bulk_cloud_model_mod.o \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	land_surface_model_mod.o \
 	mod_kinds.o \
@@ -533,4 +541,5 @@
 	bulk_cloud_model_mod.o \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	land_surface_model_mod.o \
 	mod_kinds.o \
@@ -543,4 +552,5 @@
 	urban_surface_mod.o
 diagnostic_output_quantities_mod.o: \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o \
@@ -570,4 +580,5 @@
 disturb_heatflux.o: \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o \
@@ -580,9 +591,5 @@
         pmc_interface_mod.o \
 	modules.o
-exchange_horiz.o: \
-	cpulog_mod.o \
-	mod_kinds.o \
-	modules.o
-exchange_horiz_2d.o: \
+exchange_horiz_mod.o: \
 	cpulog_mod.o \
 	mod_kinds.o \
@@ -673,4 +680,5 @@
 	vertical_nesting_mod.o
 init_grid.o: \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o \
@@ -692,8 +700,10 @@
 	vertical_nesting_mod.o
 init_pt_anomaly.o: \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o
 init_rankine.o: \
 	basic_constants_and_equations_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o
@@ -708,4 +718,5 @@
 	basic_constants_and_equations_mod.o \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	mod_particle_attributes.o \
@@ -803,7 +814,16 @@
 mod_particle_attributes.o: \
 	mod_kinds.o
+nesting_offl_mod.o: \
+	chem_modules.o \
+	cpulog_mod.o \
+	exchange_horiz_mod.o \
+	mod_kinds.o \
+	modules.o \
+	netcdf_data_input_mod.o \
+	salsa_mod.o 
 netcdf_data_input_mod.o: \
 	chem_modules.o \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o   \
@@ -828,11 +848,4 @@
 	urban_surface_mod.o \
 	user_module.o
-nesting_offl_mod.o: \
-	chem_modules.o \
-	cpulog_mod.o \
-	mod_kinds.o \
-	modules.o \
-	netcdf_data_input_mod.o \
-	salsa_mod.o 
 ocean_mod.o: \
 	advec_s_pw.o \
@@ -855,4 +868,5 @@
 	cpulog_mod.o \
 	diagnostic_output_quantities_mod.o \
+	exchange_horiz_mod.o \
 	land_surface_model_mod.o \
 	mod_kinds.o \
@@ -886,4 +900,5 @@
 plant_canopy_model_mod.o: \
 	bulk_cloud_model_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o \
@@ -936,8 +951,10 @@
 poismg_mod.o: \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o
 poismg_noopt_mod.o: \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o
@@ -946,4 +963,5 @@
 pres.o: \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o \
@@ -997,4 +1015,5 @@
 	bulk_cloud_model_mod.o \
 	calc_mean_profile.o \
+	exchange_horiz_mod.o \
 	mod_particle_attributes.o \
 	modules.o \
@@ -1043,4 +1062,5 @@
 	chem_modules.o \
 	diffusion_s.o \
+	exchange_horiz_mod.o \
 	netcdf_data_input_mod.o \
 	palm_date_time_mod.o \
@@ -1051,4 +1071,5 @@
 	mod_kinds.o
 sor.o: \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o
@@ -1081,5 +1102,5 @@
 	chem_gasphase_mod.o \
 	chem_modules.o \
-	exchange_horiz_2d.o \
+	exchange_horiz_mod.o \
 	land_surface_model_mod.o \
 	mod_kinds.o \
@@ -1102,4 +1123,5 @@
 	basic_constants_and_equations_mod.o \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o \
@@ -1125,4 +1147,5 @@
 	diagnostic_output_quantities_mod.o \
 	disturb_heatflux.o \
+	exchange_horiz_mod.o \
 	indoor_model_mod.o \
 	lagrangian_particle_model_mod.o \
@@ -1156,4 +1179,5 @@
 	cpulog_mod.o \
 	diagnostic_output_quantities_mod.o \
+	exchange_horiz_mod.o \
 	land_surface_model_mod.o \
 	mod_kinds.o \
@@ -1194,4 +1218,5 @@
 	bulk_cloud_model_mod.o \
 	cpulog_mod.o \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	mod_particle_attributes.o \
@@ -1275,4 +1300,5 @@
 	pmc_interface_mod.o
 vertical_nesting_mod.o: \
+	exchange_horiz_mod.o \
 	mod_kinds.o \
 	modules.o \
@@ -1305,4 +1331,5 @@
 	cpulog_mod.o \
 	data_output_module.o \
+	exchange_horiz_mod.o \
 	netcdf_data_input_mod.o \
 	mod_kinds.o \
Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 4456)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4414 2020-02-19 20:16:04Z suehring
 ! Move call for initialization of control flags to ws_init
 ! 
@@ -184,4 +187,7 @@
                dt_3d
 
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz_int
+
     USE indices,                                                               &
         ONLY:  advc_flags_m,                                                   &
@@ -208,8 +214,8 @@
         ONLY:  ddx, ddy
 
+    USE kinds
+
     USE pegrid,                                                                &
            ONLY:  threads_per_task
-
-    USE kinds
 
     USE statistics,                                                            &
Index: /palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- /palm/trunk/SOURCE/average_3d_data.f90	(revision 4456)
+++ /palm/trunk/SOURCE/average_3d_data.f90	(revision 4457)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added,
+! bugfix for call of exchange horiz 2d
+!
+! 4360 2020-01-07 11:25:50Z suehring
 ! Move 2-m potential temperature output to diagnostic_output_quantities
 ! 
@@ -67,6 +71,9 @@
         ONLY:  cpu_log, log_point
 
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz_2d
+
     USE indices,                                                               &
-        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
+        ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
 
     USE kinds
@@ -123,5 +130,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( ghf_av, nbgp )
+                CALL exchange_horiz_2d( ghf_av )
              ENDIF
 
@@ -133,5 +140,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( qsws_av, nbgp )
+                CALL exchange_horiz_2d( qsws_av )
              ENDIF
 
@@ -163,5 +170,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( ol_av, nbgp )
+                CALL exchange_horiz_2d( ol_av )
              ENDIF
 
@@ -284,5 +291,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( r_a_av, nbgp )
+                CALL exchange_horiz_2d( r_a_av )
              ENDIF
 
@@ -305,5 +312,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( shf_av, nbgp )
+                CALL exchange_horiz_2d( shf_av )
              ENDIF
 
@@ -315,5 +322,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( ssws_av, nbgp )
+                CALL exchange_horiz_2d( ssws_av )
              ENDIF
 
@@ -325,5 +332,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( ts_av, nbgp )
+                CALL exchange_horiz_2d( ts_av )
              ENDIF
 
@@ -335,5 +342,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( tsurf_av, nbgp )
+                CALL exchange_horiz_2d( tsurf_av )
              ENDIF
 
@@ -356,5 +363,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( us_av, nbgp )
+                CALL exchange_horiz_2d( us_av )
              ENDIF
 
@@ -399,5 +406,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( z0_av, nbgp )
+                CALL exchange_horiz_2d( z0_av )
              ENDIF
 
@@ -409,5 +416,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( z0h_av, nbgp )
+                CALL exchange_horiz_2d( z0h_av )
              ENDIF
 
@@ -419,5 +426,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( z0q_av, nbgp )
+                CALL exchange_horiz_2d( z0q_av )
              ENDIF
 
Index: /palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4418 2020-02-21 09:41:13Z raasch
 ! bugfix for raindrop number adjustment
 ! 
@@ -1311,4 +1314,7 @@
     SUBROUTINE bcm_exchange_horiz
 
+       USE exchange_horiz_mod,                                                  &
+           ONLY:  exchange_horiz
+
 
        IF ( .NOT. microphysics_sat_adjust  .AND.                                &
Index: /palm/trunk/SOURCE/chemistry_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/chemistry_model_mod.f90	(revision 4457)
@@ -27,4 +27,8 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added,
+! bugfix for call of exchange horiz 2d
+! 
+! 4442 2020-03-04 19:21:13Z suehring
 ! Change order of dimension in surface array %frac to allow for better 
 ! vectorization.
@@ -623,6 +627,9 @@
  SUBROUTINE chem_3d_data_averaging( mode, variable )
 
-
     USE control_parameters
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz_2d
+
 
     CHARACTER (LEN=*) ::  mode     !< 
@@ -717,5 +724,5 @@
                    ENDDO
                 ENDDO
-                CALL exchange_horiz_2d( chem_species(lsp)%cssws_av, nbgp )                 
+                CALL exchange_horiz_2d( chem_species(lsp)%cssws_av )
              ENDIF
           ENDDO
@@ -2760,4 +2767,7 @@
  SUBROUTINE chem_exchange_horiz_bounds
   
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
+
    INTEGER(iwp) ::  lsp       !<
    INTEGER(iwp) ::  lsp_usr   !<
Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 4456)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -112,4 +115,7 @@
         ONLY:  cpu_log, log_point
 
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
+
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg,       &
Index: /palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_3d.f90	(revision 4456)
+++ /palm/trunk/SOURCE/data_output_3d.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 ! 
@@ -105,4 +108,7 @@
     USE cpulog,                                                                &
         ONLY:  log_point, cpu_log
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     USE indices,                                                               &
Index: /palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_mask.f90	(revision 4456)
+++ /palm/trunk/SOURCE/data_output_mask.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4444 2020-03-05 15:59:50Z raasch
 ! bugfix: cpp-directives for serial mode added
 !
@@ -105,9 +108,12 @@
 #endif
 
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point
+
     USE diagnostic_output_quantities_mod,                                      &
         ONLY:  doq_output_mask
 
-    USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
 
     USE indices,                                                               &
Index: /palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90
===================================================================
--- /palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4456)
+++ /palm/trunk/SOURCE/diagnostic_output_quantities_mod.f90	(revision 4457)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added,
+! bugfix for call of exchange horiz 2d
+! 
+! 4431 2020-02-27 23:23:01Z gronemeier
 ! added wspeed and wdir output; bugfix: set fill_value in case of masked output
 !
@@ -110,4 +114,7 @@
 !     USE cpulog,                                                                &
 !         ONLY:  cpu_log, log_point
+
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz_2d
 
    USE grid_variables,                                                         &
@@ -598,5 +605,5 @@
                   ENDDO
                ENDDO
-               CALL exchange_horiz_2d( pt_2m_av, nbgp )
+               CALL exchange_horiz_2d( pt_2m_av )
             ENDIF
 
@@ -608,5 +615,5 @@
                   ENDDO
                ENDDO
-               CALL exchange_horiz_2d( uv_10m_av, nbgp )
+               CALL exchange_horiz_2d( uv_10m_av )
             ENDIF
 
Index: /palm/trunk/SOURCE/disturb_field.f90
===================================================================
--- /palm/trunk/SOURCE/disturb_field.f90	(revision 4456)
+++ /palm/trunk/SOURCE/disturb_field.f90	(revision 4457)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! use statement for exchange horiz added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
@@ -64,4 +67,7 @@
         ONLY:  cpu_log, log_point
         
+    USE exchange_horiz_mod,                                                    &
+        ONLY:  exchange_horiz
+
     USE indices,                                                               &
         ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzb_max, &
